package com.fzm.common.utils;

import cn.hutool.crypto.SecureUtil;
import com.fzm.common.enums.ResultCode;
import com.fzm.common.exception.GlobalException;

import java.util.Map;
import java.util.TreeMap;

/**
 * @author wt
 * @date 2022/4/24
 */
public class OpenSignUtils {

    public static void verify(String appKey, String appKeySecret, String bizId, String bizJson, String signature) {
        Map<String, String> param = new TreeMap<>();
        param.put("appKey", appKey);
        param.put("appKeySecret", appKeySecret);
        param.put("bizId", bizId);
        param.put("bizJson", bizJson);

        StringBuilder sb = new StringBuilder();
        for (Map.Entry<String, String> entry : param.entrySet()) {
            String key = entry.getKey();
            String value = entry.getValue();
            sb.append(key).append("=").append(value).append("&");
        }
        String signStr = sb.deleteCharAt(sb.length() - 1).toString();

        String md5 = SecureUtil.md5(signStr);
        boolean equals = signature.equals(md5);
        if (!equals) {
            throw GlobalException.newException(ResultCode.signature_wrong);
        }
    }

}
